/* explosion.cpp
 * Handles particle explosions and related stuff
 * Licensed under the Open Software License version 2.0
 * Coded by ReKleSS [rekless@fastmail.fm]
 */


#include "ss.h"
#include <stdlib.h>
#include <GL/gl.h>
#include "explosion.h"
#include <stdio.h>
#define PARTICLES 300
actor particles[PARTICLES];
float life;


void initParticles()
{				//this has to be done seperately becaues it takes ~1 second
	for (int i = 0; i < PARTICLES; i++) {
		particles[i].spdz = (rand() % 50) - 25;
		particles[i].spdx = (rand() % 50) - 25;
		particles[i].spdy = (rand() % 50) - 25;
	}
}

void explode(actor player)
{
	for (int i = 0; i < PARTICLES; i++) {
		particles[i].x = 0;
		particles[i].y = 0;
		particles[i].z = 0;
	}
	life = 2;		//2 secs
}

bool updateParticles(float SPF)
{
	for (int i = 0; i < PARTICLES; i++) {	//0 is special
		particles[i].x += particles[i].spdx * SPF;
		particles[i].y += particles[i].spdy * SPF;
		particles[i].z += particles[i].spdz * SPF;
	}
	life -= SPF;
	if (life < 0) {
		initParticles();
		return 0;
	} else
		return 1;
}

void drawParticles(float SPF)
{
	glFrontFace(GL_CCW);
	glDisable(GL_CULL_FACE);
	glEnable(GL_TEXTURE_2D);
	glDepthMask(GL_FALSE);
	glBegin(GL_POLYGON);
	glColor4f(1.0f, 1.0f, 1.0f, (life / 2));
	glTexCoord2f(0, 1);
	glVertex3f(-5, 0, 0);
	glTexCoord2f(1, 1);
	glVertex3f(5, 0, 0);
	glTexCoord2f(1, 0);
	glVertex3f(5, 10, 0);
	glTexCoord2f(0, 0);
	glVertex3f(-5, 10, 0);
	glEnd();
	glColor4f(1.0f, 1.0f, 1.0f, 0.5f);
	for (int i = 0; i < PARTICLES; i++) {
		glBegin(GL_POLYGON);
		glTexCoord2f(0, 0);
		glVertex3f(particles[i].x - 0.2f, particles[i].y - 0.2f,
			   particles[i].z);
		glTexCoord2f(0, 1);
		glVertex3f(particles[i].x + 0.2f, particles[i].y - 0.2f,
			   particles[i].z);
		glTexCoord2f(1, 1);
		glVertex3f(particles[i].x + 0.2f, particles[i].y + 0.2f,
			   particles[i].z);
		glTexCoord2f(0, 1);
		glVertex3f(particles[i].x - 0.2f, particles[i].y + 0.2f,
			   particles[i].z);
		glEnd();
	}
	glEnable(GL_CULL_FACE);
	glDepthMask(GL_TRUE);
}
